/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.check.error;

import java.util.Optional;

import de.hft.stuttgart.citydoctor2.check.CheckError;
import de.hft.stuttgart.citydoctor2.check.ErrorId;
import de.hft.stuttgart.citydoctor2.check.ErrorReport;
import de.hft.stuttgart.citydoctor2.check.ErrorType;
import de.hft.stuttgart.citydoctor2.check.ErrorVisitor;
import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.check.ModificationListener;
import de.hft.stuttgart.citydoctor2.datastructure.Geometry;
import de.hft.stuttgart.citydoctor2.datastructure.GmlElement;
import de.hft.stuttgart.quality.model.AllPolygonsWrongOrientation;
import de.hft.stuttgart.quality.model.ValidationError;

/**
 * Error when all polygons are oriented wrong.
 * 
 * @author Matthias Betz
 *
 */
public class AllPolygonsWrongOrientationError implements CheckError {

	private static final long serialVersionUID = 2263993313732858840L;
	
	private Geometry geom;

	public AllPolygonsWrongOrientationError(Geometry geom) {
		this.geom = geom;
	}

	public Geometry getGeometry() {
		return geom;
	}

	@Override
	public void accept(ErrorVisitor errorVisitor) {
		errorVisitor.visit(this);
	}

	@Override
	public boolean accept(HealingMethod method, ModificationListener l) {
		return method.visit(this, l);
	}

	@Override
	public String toString() {
		return "AllPolygonsWrongOrientationError [geom=" + geom + "]";
	}

	@Override
	public void report(ErrorReport report) {
		report.add(geom);
	}

	@Override
	public ErrorType getType() {
		return ErrorType.ERROR;
	}

	@Override
	public ErrorId getErrorId() {
		return ErrorId.GE_S_ALL_POLYGONS_WRONG_ORIENTATION;
	}

	@Override
	public GmlElement getFeature() {
		return getGeometry();
	}

	@Override
	public Optional<ValidationError> convertToQualityAdeDatastructure() {
		AllPolygonsWrongOrientation err = new AllPolygonsWrongOrientation();
		err.setGeometryId(geom.getGmlId().getGmlString());
		return Optional.of(err);
	}

}
